> For the complete documentation index, see [llms.txt](https://docs.mapsindoors.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mapsindoors.com/sdks-and-frameworks/flutter/migration-guide.md).

# Migration Guide

## Migrating from v3 to v4

### Color `String` to `Color`

All references to colors in the SDK have been changed from using a color string (which can be ambiguous in whether `aRGB` or `RGBa` is meant to be used) to using Dart `Color` instead.

{% tabs %}
{% tab title="Before" %}

```dart
final displayrule = await getMainDisplayRule();
displayrule.setLabelStyleTextColor("#FF00FF00"); // Red or transparent Purple?
```

{% endtab %}

{% tab title="After" %}

```dart
final displayrule = await getMainDisplayRule();
displayrule.setLabelStyleTextColor(Colors.red); // Definitely red
```

{% endtab %}
{% endtabs %}

### Label position

The default label position has been changed from right of the Marker to underneath the marker.

It will not be possible with the 4.0.0 to programatically change the label positioning, but this feature will become available in 4.1.0.

### `ClearWayType`

`ClearWayType` has been deprecated with the introduction of multiple `wayType` categories, going forward you should use `ClearAvoidWayType` instead.

{% tabs %}
{% tab title="Before" %}

```dart
final service = MPDirectionsService();
service.addAvoidWayType(MPHighway.steps.name);
service.addExcludeWayType(MPHighway.ladder.name);
service.clearWayType(); // What was cleared?
```

{% endtab %}

{% tab title="After" %}

```dart
final service = MPDirectionsService();
service.addAvoidWayType(MPHighway.steps.name);
service.addExcludeWayType(MPHighway.ladder.name);
service.clearAvoidWayType(); // AvoidWayTypes were cleared!
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.mapsindoors.com/sdks-and-frameworks/flutter/migration-guide.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
